package org.eclipse.gef.dot.internal.language.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.gef.dot.internal.language.services.DotColorGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDotColorParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "NumberSign", "Comma", "Solidus", "RULE_DIGITS", "RULE_ZERO_OR_ONE", "RULE_COLOR_NUMBER", "RULE_HEXADECIMAL_DIGIT", "RULE_COLOR_STRING", "RULE_WS"
    };
    public static final int RULE_WS=12;
    public static final int RULE_COLOR_STRING=11;
    public static final int RULE_DIGITS=7;
    public static final int RULE_ZERO_OR_ONE=8;
    public static final int Comma=5;
    public static final int RULE_COLOR_NUMBER=9;
    public static final int NumberSign=4;
    public static final int RULE_HEXADECIMAL_DIGIT=10;
    public static final int Solidus=6;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalDotColorParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDotColorParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDotColorParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDotColorParser.g"; }



     	private DotColorGrammarAccess grammarAccess;

        public InternalDotColorParser(TokenStream input, DotColorGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "Color";
       	}

       	@Override
       	protected DotColorGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleColor"
    // InternalDotColorParser.g:57:1: entryRuleColor returns [EObject current=null] : iv_ruleColor= ruleColor EOF ;
    public final EObject entryRuleColor() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleColor = null;


        try {
            // InternalDotColorParser.g:57:46: (iv_ruleColor= ruleColor EOF )
            // InternalDotColorParser.g:58:2: iv_ruleColor= ruleColor EOF
            {
             newCompositeNode(grammarAccess.getColorRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleColor=ruleColor();

            state._fsp--;

             current =iv_ruleColor; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleColor"


    // $ANTLR start "ruleColor"
    // InternalDotColorParser.g:64:1: ruleColor returns [EObject current=null] : (this_RGBColor_0= ruleRGBColor | this_HSVColor_1= ruleHSVColor | this_StringColor_2= ruleStringColor )? ;
    public final EObject ruleColor() throws RecognitionException {
        EObject current = null;

        EObject this_RGBColor_0 = null;

        EObject this_HSVColor_1 = null;

        EObject this_StringColor_2 = null;



        	enterRule();

        try {
            // InternalDotColorParser.g:70:2: ( (this_RGBColor_0= ruleRGBColor | this_HSVColor_1= ruleHSVColor | this_StringColor_2= ruleStringColor )? )
            // InternalDotColorParser.g:71:2: (this_RGBColor_0= ruleRGBColor | this_HSVColor_1= ruleHSVColor | this_StringColor_2= ruleStringColor )?
            {
            // InternalDotColorParser.g:71:2: (this_RGBColor_0= ruleRGBColor | this_HSVColor_1= ruleHSVColor | this_StringColor_2= ruleStringColor )?
            int alt1=4;
            switch ( input.LA(1) ) {
                case NumberSign:
                    {
                    alt1=1;
                    }
                    break;
                case RULE_COLOR_NUMBER:
                    {
                    int LA1_2 = input.LA(2);

                    if ( (LA1_2==EOF) ) {
                        alt1=3;
                    }
                    else if ( (LA1_2==Comma||LA1_2==RULE_COLOR_NUMBER) ) {
                        alt1=2;
                    }
                    }
                    break;
                case Solidus:
                case RULE_HEXADECIMAL_DIGIT:
                case RULE_COLOR_STRING:
                    {
                    alt1=3;
                    }
                    break;
            }

            switch (alt1) {
                case 1 :
                    // InternalDotColorParser.g:72:3: this_RGBColor_0= ruleRGBColor
                    {

                    			newCompositeNode(grammarAccess.getColorAccess().getRGBColorParserRuleCall_0());
                    		
                    pushFollow(FOLLOW_2);
                    this_RGBColor_0=ruleRGBColor();

                    state._fsp--;


                    			current = this_RGBColor_0;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;
                case 2 :
                    // InternalDotColorParser.g:81:3: this_HSVColor_1= ruleHSVColor
                    {

                    			newCompositeNode(grammarAccess.getColorAccess().getHSVColorParserRuleCall_1());
                    		
                    pushFollow(FOLLOW_2);
                    this_HSVColor_1=ruleHSVColor();

                    state._fsp--;


                    			current = this_HSVColor_1;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;
                case 3 :
                    // InternalDotColorParser.g:90:3: this_StringColor_2= ruleStringColor
                    {

                    			newCompositeNode(grammarAccess.getColorAccess().getStringColorParserRuleCall_2());
                    		
                    pushFollow(FOLLOW_2);
                    this_StringColor_2=ruleStringColor();

                    state._fsp--;


                    			current = this_StringColor_2;
                    			afterParserOrEnumRuleCall();
                    		

                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleColor"


    // $ANTLR start "entryRuleRGBColor"
    // InternalDotColorParser.g:102:1: entryRuleRGBColor returns [EObject current=null] : iv_ruleRGBColor= ruleRGBColor EOF ;
    public final EObject entryRuleRGBColor() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRGBColor = null;


        try {
            // InternalDotColorParser.g:102:49: (iv_ruleRGBColor= ruleRGBColor EOF )
            // InternalDotColorParser.g:103:2: iv_ruleRGBColor= ruleRGBColor EOF
            {
             newCompositeNode(grammarAccess.getRGBColorRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleRGBColor=ruleRGBColor();

            state._fsp--;

             current =iv_ruleRGBColor; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleRGBColor"


    // $ANTLR start "ruleRGBColor"
    // InternalDotColorParser.g:109:1: ruleRGBColor returns [EObject current=null] : (otherlv_0= NumberSign ( (lv_r_1_0= rulehex ) ) ( (lv_g_2_0= rulehex ) ) ( (lv_b_3_0= rulehex ) ) ( (lv_a_4_0= rulehex ) )? ) ;
    public final EObject ruleRGBColor() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        AntlrDatatypeRuleToken lv_r_1_0 = null;

        AntlrDatatypeRuleToken lv_g_2_0 = null;

        AntlrDatatypeRuleToken lv_b_3_0 = null;

        AntlrDatatypeRuleToken lv_a_4_0 = null;



        	enterRule();

        try {
            // InternalDotColorParser.g:115:2: ( (otherlv_0= NumberSign ( (lv_r_1_0= rulehex ) ) ( (lv_g_2_0= rulehex ) ) ( (lv_b_3_0= rulehex ) ) ( (lv_a_4_0= rulehex ) )? ) )
            // InternalDotColorParser.g:116:2: (otherlv_0= NumberSign ( (lv_r_1_0= rulehex ) ) ( (lv_g_2_0= rulehex ) ) ( (lv_b_3_0= rulehex ) ) ( (lv_a_4_0= rulehex ) )? )
            {
            // InternalDotColorParser.g:116:2: (otherlv_0= NumberSign ( (lv_r_1_0= rulehex ) ) ( (lv_g_2_0= rulehex ) ) ( (lv_b_3_0= rulehex ) ) ( (lv_a_4_0= rulehex ) )? )
            // InternalDotColorParser.g:117:3: otherlv_0= NumberSign ( (lv_r_1_0= rulehex ) ) ( (lv_g_2_0= rulehex ) ) ( (lv_b_3_0= rulehex ) ) ( (lv_a_4_0= rulehex ) )?
            {
            otherlv_0=(Token)match(input,NumberSign,FOLLOW_3); 

            			newLeafNode(otherlv_0, grammarAccess.getRGBColorAccess().getNumberSignKeyword_0());
            		
            // InternalDotColorParser.g:121:3: ( (lv_r_1_0= rulehex ) )
            // InternalDotColorParser.g:122:4: (lv_r_1_0= rulehex )
            {
            // InternalDotColorParser.g:122:4: (lv_r_1_0= rulehex )
            // InternalDotColorParser.g:123:5: lv_r_1_0= rulehex
            {

            					newCompositeNode(grammarAccess.getRGBColorAccess().getRHexParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_3);
            lv_r_1_0=rulehex();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getRGBColorRule());
            					}
            					set(
            						current,
            						"r",
            						lv_r_1_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.hex");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalDotColorParser.g:140:3: ( (lv_g_2_0= rulehex ) )
            // InternalDotColorParser.g:141:4: (lv_g_2_0= rulehex )
            {
            // InternalDotColorParser.g:141:4: (lv_g_2_0= rulehex )
            // InternalDotColorParser.g:142:5: lv_g_2_0= rulehex
            {

            					newCompositeNode(grammarAccess.getRGBColorAccess().getGHexParserRuleCall_2_0());
            				
            pushFollow(FOLLOW_3);
            lv_g_2_0=rulehex();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getRGBColorRule());
            					}
            					set(
            						current,
            						"g",
            						lv_g_2_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.hex");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalDotColorParser.g:159:3: ( (lv_b_3_0= rulehex ) )
            // InternalDotColorParser.g:160:4: (lv_b_3_0= rulehex )
            {
            // InternalDotColorParser.g:160:4: (lv_b_3_0= rulehex )
            // InternalDotColorParser.g:161:5: lv_b_3_0= rulehex
            {

            					newCompositeNode(grammarAccess.getRGBColorAccess().getBHexParserRuleCall_3_0());
            				
            pushFollow(FOLLOW_4);
            lv_b_3_0=rulehex();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getRGBColorRule());
            					}
            					set(
            						current,
            						"b",
            						lv_b_3_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.hex");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalDotColorParser.g:178:3: ( (lv_a_4_0= rulehex ) )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==RULE_HEXADECIMAL_DIGIT) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // InternalDotColorParser.g:179:4: (lv_a_4_0= rulehex )
                    {
                    // InternalDotColorParser.g:179:4: (lv_a_4_0= rulehex )
                    // InternalDotColorParser.g:180:5: lv_a_4_0= rulehex
                    {

                    					newCompositeNode(grammarAccess.getRGBColorAccess().getAHexParserRuleCall_4_0());
                    				
                    pushFollow(FOLLOW_2);
                    lv_a_4_0=rulehex();

                    state._fsp--;


                    					if (current==null) {
                    						current = createModelElementForParent(grammarAccess.getRGBColorRule());
                    					}
                    					set(
                    						current,
                    						"a",
                    						lv_a_4_0,
                    						"org.eclipse.gef.dot.internal.language.DotColor.hex");
                    					afterParserOrEnumRuleCall();
                    				

                    }


                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRGBColor"


    // $ANTLR start "entryRuleHSVColor"
    // InternalDotColorParser.g:201:1: entryRuleHSVColor returns [EObject current=null] : iv_ruleHSVColor= ruleHSVColor EOF ;
    public final EObject entryRuleHSVColor() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleHSVColor = null;


        try {
            // InternalDotColorParser.g:201:49: (iv_ruleHSVColor= ruleHSVColor EOF )
            // InternalDotColorParser.g:202:2: iv_ruleHSVColor= ruleHSVColor EOF
            {
             newCompositeNode(grammarAccess.getHSVColorRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleHSVColor=ruleHSVColor();

            state._fsp--;

             current =iv_ruleHSVColor; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleHSVColor"


    // $ANTLR start "ruleHSVColor"
    // InternalDotColorParser.g:208:1: ruleHSVColor returns [EObject current=null] : ( ( (lv_h_0_0= RULE_COLOR_NUMBER ) ) (otherlv_1= Comma )? ( (lv_s_2_0= RULE_COLOR_NUMBER ) ) (otherlv_3= Comma )? ( (lv_v_4_0= RULE_COLOR_NUMBER ) ) ) ;
    public final EObject ruleHSVColor() throws RecognitionException {
        EObject current = null;

        Token lv_h_0_0=null;
        Token otherlv_1=null;
        Token lv_s_2_0=null;
        Token otherlv_3=null;
        Token lv_v_4_0=null;


        	enterRule();

        try {
            // InternalDotColorParser.g:214:2: ( ( ( (lv_h_0_0= RULE_COLOR_NUMBER ) ) (otherlv_1= Comma )? ( (lv_s_2_0= RULE_COLOR_NUMBER ) ) (otherlv_3= Comma )? ( (lv_v_4_0= RULE_COLOR_NUMBER ) ) ) )
            // InternalDotColorParser.g:215:2: ( ( (lv_h_0_0= RULE_COLOR_NUMBER ) ) (otherlv_1= Comma )? ( (lv_s_2_0= RULE_COLOR_NUMBER ) ) (otherlv_3= Comma )? ( (lv_v_4_0= RULE_COLOR_NUMBER ) ) )
            {
            // InternalDotColorParser.g:215:2: ( ( (lv_h_0_0= RULE_COLOR_NUMBER ) ) (otherlv_1= Comma )? ( (lv_s_2_0= RULE_COLOR_NUMBER ) ) (otherlv_3= Comma )? ( (lv_v_4_0= RULE_COLOR_NUMBER ) ) )
            // InternalDotColorParser.g:216:3: ( (lv_h_0_0= RULE_COLOR_NUMBER ) ) (otherlv_1= Comma )? ( (lv_s_2_0= RULE_COLOR_NUMBER ) ) (otherlv_3= Comma )? ( (lv_v_4_0= RULE_COLOR_NUMBER ) )
            {
            // InternalDotColorParser.g:216:3: ( (lv_h_0_0= RULE_COLOR_NUMBER ) )
            // InternalDotColorParser.g:217:4: (lv_h_0_0= RULE_COLOR_NUMBER )
            {
            // InternalDotColorParser.g:217:4: (lv_h_0_0= RULE_COLOR_NUMBER )
            // InternalDotColorParser.g:218:5: lv_h_0_0= RULE_COLOR_NUMBER
            {
            lv_h_0_0=(Token)match(input,RULE_COLOR_NUMBER,FOLLOW_5); 

            					newLeafNode(lv_h_0_0, grammarAccess.getHSVColorAccess().getHCOLOR_NUMBERTerminalRuleCall_0_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getHSVColorRule());
            					}
            					setWithLastConsumed(
            						current,
            						"h",
            						lv_h_0_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.COLOR_NUMBER");
            				

            }


            }

            // InternalDotColorParser.g:234:3: (otherlv_1= Comma )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==Comma) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // InternalDotColorParser.g:235:4: otherlv_1= Comma
                    {
                    otherlv_1=(Token)match(input,Comma,FOLLOW_6); 

                    				newLeafNode(otherlv_1, grammarAccess.getHSVColorAccess().getCommaKeyword_1());
                    			

                    }
                    break;

            }

            // InternalDotColorParser.g:240:3: ( (lv_s_2_0= RULE_COLOR_NUMBER ) )
            // InternalDotColorParser.g:241:4: (lv_s_2_0= RULE_COLOR_NUMBER )
            {
            // InternalDotColorParser.g:241:4: (lv_s_2_0= RULE_COLOR_NUMBER )
            // InternalDotColorParser.g:242:5: lv_s_2_0= RULE_COLOR_NUMBER
            {
            lv_s_2_0=(Token)match(input,RULE_COLOR_NUMBER,FOLLOW_5); 

            					newLeafNode(lv_s_2_0, grammarAccess.getHSVColorAccess().getSCOLOR_NUMBERTerminalRuleCall_2_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getHSVColorRule());
            					}
            					setWithLastConsumed(
            						current,
            						"s",
            						lv_s_2_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.COLOR_NUMBER");
            				

            }


            }

            // InternalDotColorParser.g:258:3: (otherlv_3= Comma )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==Comma) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // InternalDotColorParser.g:259:4: otherlv_3= Comma
                    {
                    otherlv_3=(Token)match(input,Comma,FOLLOW_6); 

                    				newLeafNode(otherlv_3, grammarAccess.getHSVColorAccess().getCommaKeyword_3());
                    			

                    }
                    break;

            }

            // InternalDotColorParser.g:264:3: ( (lv_v_4_0= RULE_COLOR_NUMBER ) )
            // InternalDotColorParser.g:265:4: (lv_v_4_0= RULE_COLOR_NUMBER )
            {
            // InternalDotColorParser.g:265:4: (lv_v_4_0= RULE_COLOR_NUMBER )
            // InternalDotColorParser.g:266:5: lv_v_4_0= RULE_COLOR_NUMBER
            {
            lv_v_4_0=(Token)match(input,RULE_COLOR_NUMBER,FOLLOW_2); 

            					newLeafNode(lv_v_4_0, grammarAccess.getHSVColorAccess().getVCOLOR_NUMBERTerminalRuleCall_4_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getHSVColorRule());
            					}
            					setWithLastConsumed(
            						current,
            						"v",
            						lv_v_4_0,
            						"org.eclipse.gef.dot.internal.language.DotColor.COLOR_NUMBER");
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleHSVColor"


    // $ANTLR start "entryRuleStringColor"
    // InternalDotColorParser.g:286:1: entryRuleStringColor returns [EObject current=null] : iv_ruleStringColor= ruleStringColor EOF ;
    public final EObject entryRuleStringColor() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleStringColor = null;


        try {
            // InternalDotColorParser.g:286:52: (iv_ruleStringColor= ruleStringColor EOF )
            // InternalDotColorParser.g:287:2: iv_ruleStringColor= ruleStringColor EOF
            {
             newCompositeNode(grammarAccess.getStringColorRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleStringColor=ruleStringColor();

            state._fsp--;

             current =iv_ruleStringColor; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleStringColor"


    // $ANTLR start "ruleStringColor"
    // InternalDotColorParser.g:293:1: ruleStringColor returns [EObject current=null] : ( (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )? ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) ) ) ;
    public final EObject ruleStringColor() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_scheme_1_0=null;
        Token otherlv_2=null;
        Token lv_name_3_1=null;
        Token lv_name_3_2=null;
        Token lv_name_3_3=null;


        	enterRule();

        try {
            // InternalDotColorParser.g:299:2: ( ( (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )? ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) ) ) )
            // InternalDotColorParser.g:300:2: ( (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )? ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) ) )
            {
            // InternalDotColorParser.g:300:2: ( (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )? ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) ) )
            // InternalDotColorParser.g:301:3: (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )? ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) )
            {
            // InternalDotColorParser.g:301:3: (otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==Solidus) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // InternalDotColorParser.g:302:4: otherlv_0= Solidus ( (lv_scheme_1_0= RULE_COLOR_STRING ) )? otherlv_2= Solidus
                    {
                    otherlv_0=(Token)match(input,Solidus,FOLLOW_7); 

                    				newLeafNode(otherlv_0, grammarAccess.getStringColorAccess().getSolidusKeyword_0_0());
                    			
                    // InternalDotColorParser.g:306:4: ( (lv_scheme_1_0= RULE_COLOR_STRING ) )?
                    int alt5=2;
                    int LA5_0 = input.LA(1);

                    if ( (LA5_0==RULE_COLOR_STRING) ) {
                        alt5=1;
                    }
                    switch (alt5) {
                        case 1 :
                            // InternalDotColorParser.g:307:5: (lv_scheme_1_0= RULE_COLOR_STRING )
                            {
                            // InternalDotColorParser.g:307:5: (lv_scheme_1_0= RULE_COLOR_STRING )
                            // InternalDotColorParser.g:308:6: lv_scheme_1_0= RULE_COLOR_STRING
                            {
                            lv_scheme_1_0=(Token)match(input,RULE_COLOR_STRING,FOLLOW_8); 

                            						newLeafNode(lv_scheme_1_0, grammarAccess.getStringColorAccess().getSchemeCOLOR_STRINGTerminalRuleCall_0_1_0());
                            					

                            						if (current==null) {
                            							current = createModelElement(grammarAccess.getStringColorRule());
                            						}
                            						setWithLastConsumed(
                            							current,
                            							"scheme",
                            							lv_scheme_1_0,
                            							"org.eclipse.gef.dot.internal.language.DotColor.COLOR_STRING");
                            					

                            }


                            }
                            break;

                    }

                    otherlv_2=(Token)match(input,Solidus,FOLLOW_9); 

                    				newLeafNode(otherlv_2, grammarAccess.getStringColorAccess().getSolidusKeyword_0_2());
                    			

                    }
                    break;

            }

            // InternalDotColorParser.g:329:3: ( ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) ) )
            // InternalDotColorParser.g:330:4: ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) )
            {
            // InternalDotColorParser.g:330:4: ( (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER ) )
            // InternalDotColorParser.g:331:5: (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER )
            {
            // InternalDotColorParser.g:331:5: (lv_name_3_1= RULE_HEXADECIMAL_DIGIT | lv_name_3_2= RULE_COLOR_STRING | lv_name_3_3= RULE_COLOR_NUMBER )
            int alt7=3;
            switch ( input.LA(1) ) {
            case RULE_HEXADECIMAL_DIGIT:
                {
                alt7=1;
                }
                break;
            case RULE_COLOR_STRING:
                {
                alt7=2;
                }
                break;
            case RULE_COLOR_NUMBER:
                {
                alt7=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }

            switch (alt7) {
                case 1 :
                    // InternalDotColorParser.g:332:6: lv_name_3_1= RULE_HEXADECIMAL_DIGIT
                    {
                    lv_name_3_1=(Token)match(input,RULE_HEXADECIMAL_DIGIT,FOLLOW_2); 

                    						newLeafNode(lv_name_3_1, grammarAccess.getStringColorAccess().getNameHEXADECIMAL_DIGITTerminalRuleCall_1_0_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getStringColorRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"name",
                    							lv_name_3_1,
                    							"org.eclipse.gef.dot.internal.language.DotColor.HEXADECIMAL_DIGIT");
                    					

                    }
                    break;
                case 2 :
                    // InternalDotColorParser.g:347:6: lv_name_3_2= RULE_COLOR_STRING
                    {
                    lv_name_3_2=(Token)match(input,RULE_COLOR_STRING,FOLLOW_2); 

                    						newLeafNode(lv_name_3_2, grammarAccess.getStringColorAccess().getNameCOLOR_STRINGTerminalRuleCall_1_0_1());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getStringColorRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"name",
                    							lv_name_3_2,
                    							"org.eclipse.gef.dot.internal.language.DotColor.COLOR_STRING");
                    					

                    }
                    break;
                case 3 :
                    // InternalDotColorParser.g:362:6: lv_name_3_3= RULE_COLOR_NUMBER
                    {
                    lv_name_3_3=(Token)match(input,RULE_COLOR_NUMBER,FOLLOW_2); 

                    						newLeafNode(lv_name_3_3, grammarAccess.getStringColorAccess().getNameCOLOR_NUMBERTerminalRuleCall_1_0_2());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getStringColorRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"name",
                    							lv_name_3_3,
                    							"org.eclipse.gef.dot.internal.language.DotColor.COLOR_NUMBER");
                    					

                    }
                    break;

            }


            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleStringColor"


    // $ANTLR start "entryRulehex"
    // InternalDotColorParser.g:383:1: entryRulehex returns [String current=null] : iv_rulehex= rulehex EOF ;
    public final String entryRulehex() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_rulehex = null;


        try {
            // InternalDotColorParser.g:383:43: (iv_rulehex= rulehex EOF )
            // InternalDotColorParser.g:384:2: iv_rulehex= rulehex EOF
            {
             newCompositeNode(grammarAccess.getHexRule()); 
            pushFollow(FOLLOW_1);
            iv_rulehex=rulehex();

            state._fsp--;

             current =iv_rulehex.getText(); 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulehex"


    // $ANTLR start "rulehex"
    // InternalDotColorParser.g:390:1: rulehex returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_HEXADECIMAL_DIGIT_0= RULE_HEXADECIMAL_DIGIT this_HEXADECIMAL_DIGIT_1= RULE_HEXADECIMAL_DIGIT ) ;
    public final AntlrDatatypeRuleToken rulehex() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_HEXADECIMAL_DIGIT_0=null;
        Token this_HEXADECIMAL_DIGIT_1=null;


        	enterRule();

        try {
            // InternalDotColorParser.g:396:2: ( (this_HEXADECIMAL_DIGIT_0= RULE_HEXADECIMAL_DIGIT this_HEXADECIMAL_DIGIT_1= RULE_HEXADECIMAL_DIGIT ) )
            // InternalDotColorParser.g:397:2: (this_HEXADECIMAL_DIGIT_0= RULE_HEXADECIMAL_DIGIT this_HEXADECIMAL_DIGIT_1= RULE_HEXADECIMAL_DIGIT )
            {
            // InternalDotColorParser.g:397:2: (this_HEXADECIMAL_DIGIT_0= RULE_HEXADECIMAL_DIGIT this_HEXADECIMAL_DIGIT_1= RULE_HEXADECIMAL_DIGIT )
            // InternalDotColorParser.g:398:3: this_HEXADECIMAL_DIGIT_0= RULE_HEXADECIMAL_DIGIT this_HEXADECIMAL_DIGIT_1= RULE_HEXADECIMAL_DIGIT
            {
            this_HEXADECIMAL_DIGIT_0=(Token)match(input,RULE_HEXADECIMAL_DIGIT,FOLLOW_3); 

            			current.merge(this_HEXADECIMAL_DIGIT_0);
            		

            			newLeafNode(this_HEXADECIMAL_DIGIT_0, grammarAccess.getHexAccess().getHEXADECIMAL_DIGITTerminalRuleCall_0());
            		
            this_HEXADECIMAL_DIGIT_1=(Token)match(input,RULE_HEXADECIMAL_DIGIT,FOLLOW_2); 

            			current.merge(this_HEXADECIMAL_DIGIT_1);
            		

            			newLeafNode(this_HEXADECIMAL_DIGIT_1, grammarAccess.getHexAccess().getHEXADECIMAL_DIGITTerminalRuleCall_1());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "rulehex"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000402L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000220L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000000840L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000000E00L});

}